library ieee;
use ieee.std_logic_1164.all;

entity CONTROLER is
  port (
    CLK, RESET, TOP, BOTTOM : in std_logic;
    UP, SEL : out std_logic
  );
end CONTROLER;

architecture CONTROLER_BODY of CONTROLER is
    type T_stav is (a, b, c, d);
    signal stav , n_stav: T_stav;
    constant delay: time := 1 ns;
begin
    REG: process(CLK, RESET)
    begin
        if RESET = '1' then stav <= a;
        elsif CLK = '1' and CLK'event then stav <= n_stav;
        end if;
    end process;
    
    K2: process (stav, TOP, BOTTOM)
    begin
        case stav is
            when a => if TOP = '1' then n_stav <= b;
                                   else n_stav <= a;
                      end if;
            when b => if BOTTOM = '1' then n_stav <= c;
                                   else n_stav <= b;
                      end if;
            when c => if TOP = '1' then n_stav <= d;
                                   else n_stav <= c;
                      end if;
            when d => if BOTTOM = '1' then n_stav <= a;
                                   else n_stav <= d;
                      end if;
        end case;
    end process;

    K1: process (stav, TOP, BOTTOM)
    begin
        case stav is
            when a => if TOP = '1' then UP <= '0' after delay;
                                   else UP <= '1' after delay; SEL <= '0' after delay;
                      end if;
            when b => if BOTTOM = '1' then UP <= '1' after delay;
                                   else UP <= '0' after delay; SEL <= '0' after delay;
                      end if;
            when c => if TOP = '1' then UP <= '0' after delay;
                                   else UP <= '1' after delay; SEL <= '1' after delay;
                      end if;
            when d => if BOTTOM = '1' then UP <= '1' after delay;
                                   else UP <= '0' after delay; SEL <= '1' after delay;
                      end if;
        end case;
    end process;
end;