library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use work.GEN_CONST.all;

entity COUNTER is
    port(CLK, RESET, UP: in std_logic;
         TOP, BOTTOM: out std_logic;
         CNT: out std_logic_vector(aw downto 0));
end COUNTER;

architecture COUNTER_BODY of COUNTER is
   signal citac : std_logic_vector(aw downto 0);
begin
    P: process(CLK, RESET)
    begin
        if RESET = '1' then citac <= (others => '0');
        elsif CLK = '1' and CLK'event then
            if UP = '1' then citac <= citac + 1;
                        else citac <= citac - 1;
            end if;
        end if;
    end process;
    
   CNT <= citac after 2 ns;
   TOP <= '1' after 3 ns when (citac = mlen - 1) else
          '0' after 3 ns;
   BOTTOM <= '1' after 3 ns when (citac = 0) else
             '0' after 3 ns;
end;