library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use work.GEN_CONST.all;

entity HW2_TEST is
end HW2_TEST;

architecture TESTBENCH of HW2_TEST is

component COUNTER
    port(CLK, RESET, UP: in std_logic;
         TOP, BOTTOM: out std_logic;
         CNT: out std_logic_vector(aw downto 0));
end component;
component MEMORY
    port(ADRESS: in std_logic_vector(aw downto 0);
         CONTENT: out std_logic_vector(w - 1 downto 0));
end component;

signal T_CNT: std_logic_vector(aw downto 0);
signal T_CONT: std_logic_vector(w - 1 downto 0);
signal T_CLK: std_logic;
signal T_RESET: std_logic;
signal T_UP: std_logic;
signal T_BOTTOM: std_logic;
signal T_TOP: std_logic;

begin
  cnt: COUNTER port map (T_CLK, T_RESET, T_UP, T_TOP, T_BOTTOM, T_CNT);
  mem: MEMORY port map (T_CNT, T_CONT);

tst: process
   variable y : integer;
begin
-- run 3600
  wait for 10 ns;
  T_UP <= '1';
  y := 0;
  for i in 1 to mlen - 1 loop
    T_CLK <= '1';
    wait for 6 ns;
    assert T_CONT = y
    	    report "malfunction..."
			severity failure;
	 y := y + 3;
	 T_CLK <= '0';
	 wait for 6 ns;
  end loop;
  
  assert T_TOP = '1'
     report "malfunction... not TOP"
     severity failure;

  T_UP <= '0';
  for i in 1 to mlen - 1 loop
    T_CLK <= '1';
    wait for 6 ns;
	 y := y - 3;
--    assert T_CONT = y
--    	    report "malfunction..."
--			severity failure;
	 T_CLK <= '0';
	 wait for 6 ns;
  end loop;
  
  assert T_BOTTOM = '1'
     report "malfunction... not BOTTOM"
     severity failure;

  assert false report "Simulace skoncila" severity failure;
end process;
end TESTBENCH;
